#!/usr/bin/perl

#SYN:xvalek02

use strict; 	#hlida abychom vsude deklarovali promennou, vetsi prehlednost
use warnings;	#slouzi pro vypsani varovani

#########################################
# Autor:	Tomas Valek				 	#
# Login:	xvalek02					#
# Nazev:	syn.pl						#
# Cinnost:  Oznacuje syntax podle RV	#
#########################################

use constant TAG_LENGTH => 4;

use constant BIU_LENGTH => 3;		#bold, italic, underline, delka tagu
use constant BIU_LENGTH__ => 4;		#bold, italic, underline, delka koncoveho tagu
use constant TELETYPE_LENGTH => 4;	#teletype delka tagu
use constant TELETYPE_LENGTH__ => 5;#teletype delka koncoveho tagu
use constant SIZE_LENGTH => 13;		#size delka tagu
use constant SIZE_LENGTH__ => 7;	#size delka koncoveho tagu
use constant COLOR_LENGTH => 20;	#color delka tagu
use constant COLOR_LENGTH__ => 7; 	#color delka koncoveho tagu

use constant NUMBERS_OF_HEXA => 6;	#pocet cisel v HEX
use constant NUMBERS_OF_SIZE => 1;	#pocet cisel ve velikosti fontu

my $arg_format = 0;	#byl zadan parametr format
my $arg_input = 0;	#byl zadan parametr input
my $arg_output = 0;	#byl zadan parametr output
my $arg_br = 0;		#byl zadan parametr br
my $format_filename;#jmeno formatovaciho souboru
my $input_filename;	#jmeno vstupniho souboru
my $output_filename;#jmeno vystupniho souboru
my $file_input; 	#obsahem vstupniho souboru
my $file_output;	#obsah vystupniho souboru
my (@file_input, @file_format); #pomocne promenne pro pole vstup, vystup a soubor s formatem
my $perl_expr;  		#regularni vyraz perlu
my $actual_line = 0;	#znaci ktery radek v formatovaci souboru zpracovavame
my $number_of_lines = 0;#pocet radku v format
my $html_params; 		#formatovaci parametry
my (@tag_array, @tag_array__); #pole tag_array pro <i>, <b>,.. a tag_array__ pro ikoncujici tagy </i>, </b>,..
my $index_tag_array = 0;	#index v tagu
my ($number_size, $number_color);#velikost size ve format. souboru, cislo barvy ve format. souboru

params();   		#zpracuje parametry prikazoveho radku

get_content();  	#presune obsah souboru do promenne a soubory uzavre 

$number_of_lines = @file_format;

#kontrola:
#print "Opravdovy pocet radku v souboru $format_filename: $number_of_lines \n";

for ( my $i = 0; $i < $number_of_lines; $i++ )
{#prevedeme 1 reg vyraz, zvyrazneni syntaxe se ulozi do pole, ze ktereho se pak zvyraznuje syntaxe
	get_perl_reg_expr($i); #prevede reg. vyrazy na perlovske reg. vyrazy, co 1radek to 1 reg. vyraz
	syntax($i);
}

print_text();	#oznaci text do promenne

#--br
if ( $arg_br )
{#pridame element <br /> na konec kazdeho radku vstupniho textu
	#print "--BR\n";

	$file_output =~ s/(\n)/<br \/>$1/sg; #/komentar
}

print_out();	#vypis textu, bud na STDOUT nebo do souboru

################################################################
#							 PRINT OUT	    				   #
################################################################
sub print_out
{#vypisujeme bud na stdout nebo do souboru

	if ( $arg_output == 0 )
	{#vypisujeme na stdout
		print $file_output;
	}
	else
	{
		if ( (open(FILE_OUTPUT, ">$output_filename")) == 0 )
		{
			print_error_and_exit(3, $output_filename);
		}
		print FILE_OUTPUT $file_output;
	}

	exit(0);
}
################################################################
#					 CHECK VALID HTML FORMAT	    		   #
################################################################
sub check_valid_html_format
{#overi zda jsou ve formatu validni html parametry bold,italic,teletype,underline,size:,color:

	my $valid = 0; #inicializace na false tzn. nevalidni

	if ( (index($html_params, "bold") != -1) or (index($html_params, "italic") != -1) or (index($html_params, "underline") != -1) or (index($html_params, "teletype") != -1) )
	{
		$valid = 1;
	}
	elsif (index($html_params, "size:") != -1)
	{#overeni zda je size spravne zadane, musi to byt 1 cislo v rozsahuj 1-7

		my $size_number;		#vytahne velikost cisla
		my $number_of_numbers;	#pocet cisel musi byt 1

		while( ($html_params =~/size:/sg) )
		{#prohledavame vsechny size

			$number_of_numbers = 0;	#pocet cisel

			#vyparserujeme velikost, $+[0] nam udava, na jakem indexu v $html_params se toto cislo nachazi, NUMBERS_OF_SIZE nam udava, kolikati mistne bude
			$size_number = substr($html_params, $+[0], NUMBERS_OF_SIZE);

			$number_of_numbers = $size_number =~ s/([1-9])/$1/sg; #pocet cisel

			if ( $number_of_numbers =~ m/[0-9]+/ and $size_number > 0 and $size_number < 8 )
			{#pokud to je cislo a pokud je od 1-7 vcetne, tak je validni
				$valid = 1;
			}
			else
			{#jinak neni validni, konec cyklu a nakonci podprogramu chyba
				$valid = 0;
				last;
			}
		}
	}
	elsif (index($html_params, "color:") != -1)
	{#zkontrolujeme zda je hexa zadano jako 6 cisel a zda obsahuje pouze HEXa cislice

		my $hexa_number;		#vytahne cislo HEX
		my $number_of_numbers;	#pocet HEXa cisel, musi byt 6

		while( ($html_params =~/color:/sg) )
		{#prohledavame vsechny color

			$number_of_numbers = 0;	#pocet cisel

			#vyparsrujeme HEXa cislo, $+[0] nam udava, na jakem indexu v $html_params toto cislo zacina, NUMBERS_OF_HEXA nam udava, kolik dalsich cisel chcem ulozit
			$hexa_number = substr($html_params, $+[0], NUMBERS_OF_HEXA);

			$number_of_numbers = $hexa_number =~ s/([0-9A-F])/$1/sg; #pocet cisel

			if ( $number_of_numbers == NUMBERS_OF_HEXA )
			{#pocet hexa cislic musi byt 6, jinak chyba
				$valid = 1;
			}
			else
			{
				$valid = 0;
				last;
			}
		}
	}

	if ( $valid == 0 )
	{#pokud nebyl nastaven valid, znamena to chybu
		print_error_and_exit(4, $format_filename);
	}
}
#################################################################
#						  PRINT_TEXT						  	#
#################################################################
sub print_text
{#oznaci text do promenne

	my $number_of_tags;		#pocet tagu(musi byt sude cislo) jeden tag napr: 0#<b># <b> se pocita za 1 polozku
	my $file_input_length;	#$file_input do indexu rozdeleny, delka $file_input

	$file_output = $file_input;	#z principu, abychom neupravovali file_input

	#@tag_array		je pole v nemz jsou oteviraci tagy
	#@tag_array__	je pole v nemz jsou uzaviraci tagy
	#@file_input	je pole v nem je vychozi text

	@file_input = split(//, $file_input);
	$file_input_length = @file_input;	#ziskani delky $file_input

	$number_of_tags = @tag_array / TAG_LENGTH;

	for( my $i = $file_input_length; $i >= 0; $i-- )
	{
		my $what;

		for ( my $j = $number_of_tags*TAG_LENGTH-(TAG_LENGTH); $j >= 0; $j -= TAG_LENGTH )
		{
			if ( $i == $tag_array[$j])
			{#na tento index neco davame z @tag_array
				$what = $tag_array[$j+2];
				substr($file_output, $i, 0, $what);#/
			}
		}

		for ( my $j = 0; $j < $number_of_tags*TAG_LENGTH; $j += TAG_LENGTH )
		{
			if ( $i == $tag_array__[$j])
			{#na tento index neco davame z @tag_array
				$what = $tag_array__[$j+2];
				substr($file_output, $i, 0, $what);#/
			}
		}
	}
}
#################################################################
#					  PUSH TAG TO ARRAY					  		#
#################################################################
sub push_tag_to_array
{#vytvari pole tagu to jsou tagy <i>, <b>,..
#		  pole koncovych tagu, to jsou tagy </i>, </b>,..
#pole jsou ve tvaru:index_tagu#tag# napr 1#<b>#

	my ($word, $char) = @_;

	my $tag_length;		#delka tagu
	my $tag_length__;	#delka koncoveho tagu
	my $pair_tag_lenght;#soucet delky tagu+koncoveho tagu, napr. <b>+</b> = 7, slouzi pro spravny vypocet indexu

	my $tmp_rv = $file_input;	#tmp, abychom nepracovali s $file_input
	my $index_i = 0;			#index <i>, nebo <b>, ..
	my $index__i = 0;			#index </i>, nebo </b>, ..

	my $empty_index = 0;		#pocitadlo prazdnych oznacenych vyrazu, napr. <b></b>

	my $od_ = 0;	#od jakeho indexu se bude pokracovat vyhledavani pro tagy
	my $od__ = 0;	#od jakeho indexu se bude pokracovat vyhledavani pro koncove tagy

	my $number_tag_array = 0;	#cislo tagu

	#nastavime delky tagu, podle toho s cim pracujeme
	if ( ($word eq "bold") or ($word eq "italic") or ($word eq "underline") )
	{
		$tag_length = BIU_LENGTH;
		$tag_length__ = BIU_LENGTH__;

		$tmp_rv =~ s/($perl_expr)/<$char>$1<\/$char>/sg; #/komentar
	}
	elsif ( $word eq "teletype" )
	{
		$tag_length = TELETYPE_LENGTH;
		$tag_length__ = TELETYPE_LENGTH__;

		$tmp_rv =~ s/($perl_expr)/<$char>$1<\/$char>/sg; #/komentar
	}
	elsif ( $word eq "size" )
	{
		$tag_length = SIZE_LENGTH;
		$tag_length__ = SIZE_LENGTH__;

		$tmp_rv =~ s/($perl_expr)/<font size=$number_size>$1<\/font>/sg; #/komentar
	}
	elsif ( $word eq "color" )
	{
		$tag_length = COLOR_LENGTH;
		$tag_length__ = COLOR_LENGTH__;

		$tmp_rv =~ s/($perl_expr)/<font color=#$number_color>$1<\/font>/sg; #/komentar
	}

	$pair_tag_lenght = $tag_length+$tag_length__;

	while( 1 )
	{#v cyklu musime prohledat vsechna oznaceni daneho typu, skoncime, az nic nenajdeme

		#najdu index, $od znamena od minuleho nalezeni <i>,nebo <b>, ..
		if ( ($word eq "bold") or ($word eq "italic") or ($word eq "underline") or ($word eq "teletype") )
		{
			$index_i = index($tmp_rv,"<$char>", $od_);
		}
		elsif ( $word eq "size" )
		{
			$index_i = index($tmp_rv,"<font size=", $od_);
		}
		elsif ( $word eq "color" )
		{
			$index_i = index($tmp_rv,"<font color=", $od_);
		}
			
		$od_ = $index_i+$tag_length;	#odkud budeme priste vyhledavat, index posledniho nalezeni+delka tagu

		#spravne odectu pocet predchozich tagu
		$index_i = $index_i - $number_tag_array*$pair_tag_lenght - $empty_index*$pair_tag_lenght; #od indexu odecitam dosud zaznamenane tagy, abych se dostal na orig. indexy vstupniho souboru
		#print("*index:$index_i\n");

		if ( $index_i <= -1 )
		{#pokud tam napr: <i> neni, nic se nevyznacilo a funkce konci
			last;
		}

		#najdu index, $od znamena od minuleho nalezeni </i>, nebo </b>, ..
		if ( ($word eq "bold") or ($word eq "italic") or ($word eq "underline") or ($word eq "teletype") )
		{
			$index__i = index($tmp_rv,"</$char>", $od__);
		}
		elsif ( ($word eq "size") or ($word eq "color") )
		{
			$index__i = index($tmp_rv,"</font>", $od__);
		}

		$od__ = $index__i+$tag_length__;	#odkud budeme priste vyhledavat, index posledniho nalezeni+delka tagu

		$index__i = $index__i - $number_tag_array*$pair_tag_lenght - $tag_length - $empty_index*$pair_tag_lenght; #od indexu odecitam dosud zaznamenane tagy, abych se dostal na orig. indexy vstupniho souboru
		#print("**index:$index__i\n");

		if ( $index__i <= -1 )
		{#pokud tam napr: </i> neni, nic se nevyznacilo a funkce konci
			last;
		}#tohle si myslim ze tu byt nemusi, zatim jsem ponechal

		if ( $index_i == $index__i )
		{#pokud je oznacena 0delka, jedna se o oznaceni prazdneho retezce, inkrementujeme promenou prazdny index a neukladame tag
			$empty_index++;
			next;
		}

		#ulozim si potrebna data do poli tag_array a tag_array__
		#poctacecni tag
		#koncovy tag
		#poctacecni tag
		#koncovy tag
		#a stale se to strida
		$tag_array[$index_tag_array] = $index_i;
		$tag_array__[$index_tag_array] = $index__i;
		$index_tag_array++;
		$tag_array[$index_tag_array] = "#";
		$tag_array__[$index_tag_array] = "#";
		$index_tag_array++;

		if ( ($word eq "bold") or ($word eq "italic") or ($word eq "underline") or ($word eq "teletype") )
		{
			$tag_array[$index_tag_array] = "<$char>";
			$tag_array__[$index_tag_array] = "</$char>";
		}
		elsif ( $word eq "size" )
		{
			$tag_array[$index_tag_array] = "<font size=$number_size>";
			$tag_array__[$index_tag_array] = "</font>";
		}
		elsif ( $word eq "color" )
		{
			$tag_array[$index_tag_array] = "<font color=#$number_color>";
			$tag_array__[$index_tag_array] = "</font>";
		}

		$index_tag_array++;
		$tag_array[$index_tag_array] = "#";
		$tag_array__[$index_tag_array] = "#";
		$index_tag_array++;

		$number_tag_array++;	#dalsi tag
	}
}
#################################################################
#							 SYNTAX						   		#
#################################################################
sub syntax
{#vyznaci syntax
	my ($actual_line) = @_;
	my @html_params;		#pole pro ulozeni html parametru
	my $number_html_params; #pocet html parametru

	#zrusi tabulatory a mezery nahradi je jednim tabulatorem a jednou mezerou
	$file_format[$actual_line] =~ s/\t+/\t/sg; 
	$file_format[$actual_line] =~ s/( )+/ /sg;

	$html_params = $file_format[$actual_line];
	#print "Kontrola html_params:$html_params \n";

	#zjistime si jake mame formatovaci parametry pro HTML
	$html_params =~ s/([^\t]*)(.*)/$2/sg;
	$html_params =~ s/\s//sg;
	@html_params = split(/,/, $html_params);
	#print "Parametry html jsou:@html_params\n";

	#overime aktualni radek formatovacich parametru, zda je validni
	check_valid_html_format();

	my @size = $html_params =~ /size:([1-7])/sg; #do size pole si ulozime nalezene velikosti
	my @color = $html_params =~ /color:([0-9a-fA-F]{6})/sg; #zjisteni cisla HEX

	my $actual_size_index = 0;	#index do pole size
	my $actual_color_index = 0;	#index do pole color

	$number_html_params = @html_params;	#pocet html params

	for ( my $i = 0; $i < $number_html_params; $i++ )
	{#zavolame funkci aby oznacila jednu syntaxi pro kazdy html parametr do pole
		if ( ($html_params[$i]) eq "bold" )
		{
			push_tag_to_array("bold", 'b');
		}
		if ( ($html_params[$i]) eq "italic" )
		{
			push_tag_to_array("italic", 'i');
		}
		if ( ($html_params[$i]) eq "underline" )
		{
			push_tag_to_array("underline", 'u');
		}
		if ( ($html_params[$i]) eq "teletype" )
		{
			push_tag_to_array("teletype", 'tt');
		}
		if ( index($html_params[$i], "size") != -1 )
		{
			$number_size = $size[$actual_size_index];
			push_tag_to_array("size", 'size');
			$actual_size_index++;
		}
		if ( index($html_params[$i], "color") != -1 )
		{
			$number_color = $color[$actual_color_index];
			push_tag_to_array("color", 'color');
			$actual_color_index++;
		}
	}
};
#################################################################
#			   GET PERL REGULAR EXPRESSION						#
#################################################################
sub get_perl_reg_expr
{#prevede reg. vyrazy na perlovske reg. vyrazy

	my ($actual_line) = @_;	#parametr funkce

	#vytahneme reg. vyraz z promenne file_format, split nam ho rozdeli pomoci tabu a nas zajima hned prvni vec, to je reg. vyraz
	my $actual_expr = (split(/\t/, $file_format[$actual_line]))[0];

	#kontrola RV:
	$_ = $actual_expr;
	if ( /%/ and !/%[sadlLwWtn.|!*+()%]/ )
	{#znak za % nevyhovuje
		print_error_and_exit(4, $format_filename, $actual_expr);
	}
	elsif ( /\.{2,}/ or /\+{2,}/ or /\*{2,}/ or /\|{2,}/ or /\!{2,}/ or /%{3,}/ )
	{#znak '.''+''*' atd. muze byt pouze 1, takze pokud je 2 a vic za sebou tak chyba u % jsou to 3 a vice znaku za sebou
		print_error_and_exit(4, $format_filename, $actual_expr);
	}
	elsif( /\.[\|*+)]/ or /\|[.*+)]/ or /![.\|*+)]/ or /\*[!+]/ or /\+[!*]/ )
	{#validnost RV
		print_error_and_exit(4, $format_filename, $actual_expr);
	}
	elsif( /^[.|*+)]/ or /[^%][.|!(]$/ )
	{#zacatek radku nesmi zacina .|*+ a konec nesmi koncit .|!(
		print_error_and_exit(4, $format_filename, $actual_expr);
	}

	if ( /!%a/ )
	{#!%a nevyhovi nikdy zadny RV, takze preskakujeme tim zpusobem, ze do actual_expr dame "" a tim padem se to uz na nic neupravi a nic nevyhovi
		$actual_expr="";
	}

	$actual_expr =~ s/\\/\\\\/sg;	# \ za \\, musi byt zde, aby se to nebylo s %( oznaci \( a pak by se to nahradilo za \\( a to by byla chyba
#print "[0.5]$actual_expr \n";

	#potlaceni meta znaku \ ^ $ [ ? {
	$actual_expr =~ s/\^/\\^/sg;
	$actual_expr =~ s/\$/\\\$/sg;
	$actual_expr =~ s/\[/\\[/sg;
	$actual_expr =~ s/\]/\\]/sg;
	$actual_expr =~ s/\?/\\?/sg;
	$actual_expr =~ s/\{/\\{/sg;
	$actual_expr =~ s/\//\\\//sg;

	#regularni vyrazy, priorita ! > *,+ > . > |
	$actual_expr =~ s/!(\%.)/\[^$1\]/sg;		#!%a -> [^%a]   #chova se to nejak naopak[.] neoznaci nic :-D

	$actual_expr =~ s/!(.)/\[^$1\]/sg;			#!a -> [^a]
	$actual_expr =~ s/([^%])\./$1/sg;			#A.B -> AB

	#specialni regularni vyrazy
	$actual_expr =~ s/%s/( |\f|\n|\r|\t|\013)/sg; #bile znaky ( \t\n\r\f\v)
	$actual_expr =~ s/%a/(.|\n)/sg; 		#jeden libovolny + konec radku
	$actual_expr =~ s/%d/[0-9]/sg;
	$actual_expr =~ s/%l/[a-z]/sg;
	$actual_expr =~ s/%L/[A-Z]/sg;
	$actual_expr =~ s/%w/[a-zA-Z]/sg;		#mala a velka pismena
	$actual_expr =~ s/%W/[a-zA-Z0-9]/sg; 	#vsechna pismena a cisla [a-zA-Z_0-9]
	$actual_expr =~ s/%t/\t/sg; 
	$actual_expr =~ s/%n/\\n/sg;

	#specialni symbol
	$actual_expr =~ s/%\./\\./sg; #tecka
	$actual_expr =~ s/%\|/\\|/sg; #svislitko
	$actual_expr =~ s/%\!/!/sg;
	$actual_expr =~ s/%\*/\\*/sg;
	$actual_expr =~ s/%\+/\\+/sg;
	$actual_expr =~ s/%\(/\\(/sg;
	$actual_expr =~ s/%\)/\\)/sg;
	$actual_expr =~ s/%\%/\%/sg;

	$perl_expr = $actual_expr;

	#zkontrolujeme, zda uzivatel zadal validni regularni vyraz:
	eval {/$perl_expr/;};

	if ($@)
	{#spatny RV
		print_error_and_exit(4, $format_filename, $perl_expr);
	}
}
#################################################################
#						GET CONTENT						   		#
#################################################################
sub get_content
{#podprogram presune obsah souboru do promenne
#FILE_FORMAT do file_format
#FILE_INPUT do file_input v pripade nezadani jde do file_input STDIN

	my ($FILE_FORMAT, $FILE_INPUT);#obsah otevreneho souboru

	$FILE_FORMAT = "";
	$FILE_INPUT = "";

	my $i;	#slouzi pro foreach

	#ARG_FORMAT
	if ( $arg_format )
	{
		if( (open(FILE_FORMAT, "<$format_filename")) == 0)
		{
			print_error_and_exit(2, $format_filename);
		}

		#otevreny soubor si zkopirujeme do promenne a soubor zavreme
		@file_format = <FILE_FORMAT>;

		close FILE_FORMAT;
	}

	#ARG_INPUT
	if ( !$arg_input )
	{#vstup z STDIN

		$file_input = <STDIN>;
		 chomp $file_input;
	}
	else
	{
		if ( (open(FILE_INPUT, "<$input_filename")) == 0)
		{
			print_error_and_exit(2, $input_filename);
		}

		@file_input = <FILE_INPUT>;

		close FILE_INPUT;

		foreach $i (@file_input)
		{#zkopirujeme pole do promenne
			$file_input = $file_input.$i;
		}

		if ( @file_input == 0 )
		{#pokud je vstup prazdny, muzeme rovnou vypsat prazdny soubor
			#print_out();
			$file_input = "";
		}
	}
}
#################################################################
#					   PARAMS									#
#################################################################
sub params
{#zjisti parametry a osetri --help, zadny parametry nesmi byt zadany 2x

	my $i;
	my $arg_help;

	$i = 0;
	$arg_help = 0;

	foreach (@ARGV)
	{#zpracujeme jaky parametr byl zadan a kolikrat

		if ( $ARGV[$i] eq "--help" )
			{ $arg_help++; }
		elsif ( $ARGV[$i] =~ m/--format[=].*/ ) 
		{ 
			$arg_format++;
			#rozdeli retezec na dva od = do, ulozi druhy prvek pole do $format_filename a pokud tam nic neni, ulozime do nej prazdny retezec
			$format_filename = (split(/=/, $ARGV[$i]))[1];
			if ( !$format_filename ){$format_filename = "";}
		}
		elsif ( $ARGV[$i] =~ m/--input[=].*/ )
		{
			$arg_input++;
			$input_filename = (split(/=/, $ARGV[$i]))[1];
			if ( !$input_filename ){$input_filename = "";}
		}
		elsif ( $ARGV[$i] =~ m/--output[=].*/ )
		{
			$arg_output++;
			$output_filename = (split(/=/, $ARGV[$i]))[1];
			if ( !$output_filename ){$output_filename = "";}
		}
		elsif ( $ARGV[$i] eq "--br" )
		{
			$arg_br++;
		}
		else
		{#parametr nevyhovuje
			print_error_and_exit(1);
		}

		$i++;
	}

	if ( ($arg_help > 1) or ($arg_format > 1) or ($arg_input > 1) or ($arg_output > 1) or ($arg_br > 1) )
	{#osetrime zda nejaky parametr neni zadany vicekrat
		print_error_and_exit(1);
	}

	if ( $arg_help == 1 )
	{#aktivni parametr help

		if (($arg_format >= 1) or ($arg_input >= 1) or ($arg_output >= 1) or ($arg_br >= 1) )
		{# pokud je k helpu aktivni jeste nejaky jiny, tak chyba
			print_error_and_exit(1);
		}
		else
		{#neni aktivni zadny jiny nez help
			help();
		}
	}
}
#################################################################
#						 HELP								 	#
#################################################################
sub help
{
print "#################################################################
#                     ZVYRAZNENI SYNTAXE                        #
# Autor:    Tomas Valek                                         #
# Login:    xvalek02                                            #
# Nazev:    syn.pl                                              #
# Cinnost:  Skript automaticky zvyraznuje ruzne casti textu.    #
#                                                               #
# Popis parametru:                                              #
#--help                                                         #
#Vypise tuto obrazovku s napovedou.                             #
#                                                               #
#--format=filename                                              #
#Cesta k formatovacimu souboru.                                 #
#                                                               #
#--input=filename                                               #
#Urceni vstupniho souboru.                                      #
#                                                               #
#--output=filename                                              #
#Urceni vystupniho souboru. Pokud neni soubor zadan, je pouzit  #
#vstup z STDIN.                                                 #
#                                                               #
#--br                                                           #
#Pridava element <br /> na konec radku puvodniho vstupniho sou-	#
#boru.                                                          #
#                                                               #
#Zadny z parametru neni povinny.                                #
#################################################################
";
exit(0);
}

#################################################################
#				PRINT_ERROR_AND_EXIT							#
#################################################################
sub print_error_and_exit
{#Podprogram vypise na STDERR chybu a ukonci program s odpovidajici chybou
	my ($number_err, $filename) = @_;

	if ( $number_err == 1 )
	{
		print STDERR "Spatne pouzite parametry. Pro napovedu spustte program s parametrem --help.\n";
	}
	elsif ( $number_err == 2 )
	{
		print STDERR "Chyba pri praci se souborem: \"$filename\"\n";
	}
	elsif ( $number_err == 3 )
	{
		print STDERR "Vystupni soubor: \"$filename\" se nepodarilo otevrit.\n";
	}
	elsif ( $number_err == 4 )
	{
		print STDERR "Formatovaci soubor: \"$filename\" neni validni.\n";
	}

	exit($number_err);
}
